//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Thu Jul  5 12:04:56 PDT 2001
// Last Modified: Thu Jul  5 12:04:59 PDT 2001
// Filename:      ...sig/maint/code/Generator/AudioIn/AudioIn.h
// Web Address:   http://sig.sapp.org/include/sigSignal/AudioIn.h
// Documentation: http://sig.sapp.org/doc/classes/AudioIn
// Syntax:        C++ 
//
// Description:   buffered audio input.
//

#ifndef _AUDIOIN_H_INCLUDED
#define _AUDIOIN_H_INCLUDED


#include "Generator.h"
#include "AudioInputStream.h"
#include "Array.h"

#include <assert.h>

#ifndef OLDCPP
   #include <iostream>
   #include <fstream>
   using namespace std;
#else
   #include <iostream.h>
   #include <fstream.h>
#endif

typedef unsigned short ushort;


class AudioIn : public Generator {
   public:
                        AudioIn               (void);
                       ~AudioIn();

      void              action                (void);
      short             extractSample16Bit    (void);
      int               getBitsPerSample      (void);
      int               getChannels           (void);
      sampleType        output                (int channel = 0);
      void              printState            (void);
      void              reset                 (int sampleIndex = 0);
      void              open                  (void);
      void              open16LSB             (int channels, int srate);
      void              close                 (void);

   protected:
      AudioInputStream    audioin;         // audio stream input
      Array<sampleType>   Output;          // output values
      
      int                 framesize;       // size of the audio buffer
      int                 framei;          // current point in audio buffer
      ushort*             audiobuffer;     // current audiobuffer storage
};
        


#endif  /* _AUDIOIN_H_INCLUDED */



// md5sum: f9d1253448ec31fee0ebd1022f3ecfd6 AudioIn.h [20050403]
