//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Thu Jul  5 14:03:25 PDT 2001
// Last Modified: Thu Jul  5 14:03:28 PDT 2001
// Filename:      ...sig/maint/code/audio/AudioInputStream/unix/AudioInputStream.h
// Web Address:   http://sig.sapp.org/include/sig/AudioInputStream.h
// Documentation: http://sig.sapp.org/doc/classes/AudioInputStream
// Syntax:        C++ 
//

#ifndef _AUDIOINPUTSTREAM_H_INCLUDED
#define _AUDIOINPUTSTREAM_H_INCLUDED

#ifdef VISUAL
   #define AUDIOINPUTSTREAM  AudioIn_visual
   #include "AudioInputStream_visual.h"  // not written yet
#elif defined(LINUX)
   #define AUDIOINPUTSTREAM  AudioInputStream_unix
   #include "AudioInputStream_unix.h"
#elif defined(LINUX) && defined(ALSA) && defined(OSS)
   #define AUDIOINPUTSTREAM  AudioInputStream_unix
   #include "AudioInputStream_unix.h"
#elif defined(LINUX) && defined(ALSA) && !defined(OSS)
   #define AUDIOINPUTSTREAM  AudioInputStream_unix
   #include "AudioInputStream_unix.h"
#elif defined (LINUX) && defined(OSS) && !defined(ALSA)
   #define AUDIOINPUTSTREAM  AudioInputStream_unix
   #include "AudioInputStream_unix.h"
#elif defined(LINUX)
   #define AUDIOINPUTSTREAM  AudioInputStream_unix
   #include "AudioInputStream_unix.h"
#else
   #define AUDIOINPUTSTREAM  AudioInputStream_unsupported
   #include "AudioInputStream_unsupported.h"  // not written yet
#endif


class AudioInputStream : protected AUDIOINPUTSTREAM {
   public:

               AudioInputStream    (void) : AUDIOINPUTSTREAM() { }
              ~AudioInputStream    (void) { }
      ushort*  getNextBuffer       (void) { return AUDIOINPUTSTREAM::getNextBuffer(); }
      int      getBufferSize       (void) { return AUDIOINPUTSTREAM::getBufferSize(); }

      void  open                   (void) { AUDIOINPUTSTREAM::open(); }
      void  open16LSB              (int channels, int srate) 
            { AUDIOINPUTSTREAM::open16LSB(channels, srate); }
      void  close                  (void) { AUDIOINPUTSTREAM::close(); }

};



#endif  /* _AUDIOINPUTSTREAM_H_INCLUDED */



// md5sum: cedb10b32c1a95e66d6bbf4e94536ec4 AudioInputStream.h [20010708]
