//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Apr 20 19:02:37 GMT-0800 1997
// Last Modified: Sun Apr 20 19:02:40 GMT-0800 1997
// Last Modified: Mon Jul  9 18:18:23 PDT 2001
// Filename:      ...sig/maint/code/Filter/Comb/Comb.h
// Web Address:   http://sig.sapp.org/include/sigSignal/Comb.h
// Documentation: http://sig.sapp.org/doc/classes/Comb
// Syntax:        C++ 
//

#ifndef _COMB_H_INCLUDED
#define _COMB_H_INCLUDED


#include "Filter.h"
//#include "Delay.h"
#include "CircularBuffer.h"


class Comb : public Filter {
   public:
                         Comb            (void);
                        ~Comb            ();
      void               action          (void);
      void               clear           (void);
      int                getDelaySamples (void);
      sampleType         getFund         (void);
      sampleType         getGain         (void);
      sampleType         getLoopTime     (void);
      sampleType         getMinFund      (void);
      sampleType         getReverbTime   (void);
      sampleType         getSignal       (void);
      sampleType         output          (int index);
      void               setDelaySamples (int aDelay);
      void               setFund         (sampleType aFund);
      void               setLoopTime     (sampleType aLoopTime);
      void               setMinFund      (sampleType aMin);
      void               setReverbTime   (sampleType aReverbTime);
      void               setGain         (sampleType aScale);
 
   protected:
      sampleType                 outputValue;
      CircularBuffer<sampleType> circularQueue;
      int                        buffsize;
      int                        maxbuffsize;

      void               setQueueSize   (int size);
};



#endif  // _COMB_H_INCLUDED



// md5sum: 5f5138925894f934a8968907a366c714 Comb.h [20050403]
