//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Apr 27 11:19:52 GMT-0800 1997
// Last Modified: Sun Apr 27 11:19:55 GMT-0800 1997
// Filename:      ...sig/maint/code/Filter/Delayline/Delayline.h
// Web Address:   http://sig.sapp.org/include/sigSignal/Delayline.h
// Documentation: http://sig.sapp.org/doc/classes/Delayline
// Syntax:        C++ 
//

#ifndef _DELAYLINE_H_INCLUDED
#define _DELAYLINE_H_INCLUDED

#include "Delay.h"
#include "Filter.h"


class Delayline : public Filter, public Delay {
   public:
                       Delayline          (int delay = 1);
                      ~Delayline          ();

      void             action             (void);
      ulong            getDelay           (void);
      sampleType       output             (int index);
      sampleType       output             (float index);
      sampleType       output             (double index)
                                             { return output((float)index); };
      void             setDelay           (long delayamount);

   protected:
      long             delayAmount;

};



#endif  /* _DELAYLINE_H_INCLUDED */



// md5sum: a59d9776513ec8655c09e9abd6cee8db Delayline.h [20010708]
