//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Wed Apr 30 14:55:47 GMT-0800 1997
// Last Modified: Wed Apr 30 14:55:51 GMT-0800 1997
// Filename:      ...sig/maint/code/Generator/FixedSine/FixedSine.h
// Web Address:   http://sig.sapp.org/include/sigSignal/FixedSine.h
// Documentation: http://sig.sapp.org/doc/classes/FixedSine
// Syntax:        C++ 
//

#ifndef _FIXEDSINE_H_INCLUDED 
#define _FIXEDSINE_H_INCLUDED 


#include "Generator.h"

typedef unsigned long ulong;

class FixedSine : public Generator {
   public:
                      FixedSine         (float aFrequency, 
                                            float anAmplitude = 1.0, 
                                            float aPhase = 0.0,
                                            float aSrate = 44100.0);
                     ~FixedSine         ();
                      
      void            action            (void);
      float           getAmplitude      (void);
      float           getFrequency      (void);
      float           getPhase          (void);
      sampleType      output            (int channel);
      void            printState        (void);
      void            reset             (void);
      void            setAmplitude      (float anAmplitude);
      void            setFrequency      (float aFequency);
      void            setPhase          (float aPhase);

   protected:
      sampleType      outputValue;
      ulong           sampleNum;
      float           amplitude;
      float           angularFrequency;
      float           phase;
};



#endif  /* _FIXEDSINE_H_INCLUDED */



// md5sum: f36a08208882729a878ba1404ba1375e FixedSine.h [20010708]
