//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sat Apr 19 20:45:43 GMT-0800 1997
// Last Modified: Sat Apr 19 20:45:46 GMT-0800 1997
// Filename:      ...sig/maint/code/Generator/Function/Function.h
// Web Address:   http://sig.sapp.org/include/sigSignal/Function.h
// Documentation: http://sig.sapp.org/doc/classes/Function
// Syntax:        C++ 
//

#ifndef _FUNCTION_H_INCLUDED 
#define _FUNCTION_H_INCLUDED 


#include "Generator.h"

typedef sampleType (*funcPtr)(double timeValue);


class Function : public Generator {
   public:
                      Function          (funcPtr aFunction);
                     ~Function          ();
                      
      void            action            (void);
      sampleType      output            (int channel);
      void            reset             (double newTime = 0);
      void            setFunction       (funcPtr aFunction);
      void            printState        (void);

   protected:
      funcPtr         generatingFunction;
      double          timeVariable;
      sampleType      outputValue;
};



#endif  /* _FUNCTION_H_INCLUDED */



// md5sum: 3364d9aeb4d9d3c61f6b0ef37b4ef6aa Function.h [20010708]
