//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Thu May  8 00:16:50 GMT-0800 1997
// Last Modified: Thu May  8 00:16:53 GMT-0800 1997
// Filename:      ...sig/maint/code/Filter/LinuxSoundOut/LinuxSoundOut.h
// Web Address:   http://sig.sapp.org/include/sigSignal/LinuxSoundOut.h
// Documentation: http://sig.sapp.org/doc/classes/LinuxSoundOut
// Syntax:        C++ 
//

#ifndef _LINUXSOUNDOUT_H_INCLUDED
#define _LINUXSOUNDOUT_H_INCLUDED


#include "Filter.h"
#include "Array.h"

#include "RTSoundIO.h"

class LinuxSoundOut : public Filter {
   public:
                         LinuxSoundOut  (MY_FLOAT srate, int channels, int port = 0);
                        ~LinuxSoundOut  ();

      void               action         (void);
      sampleType         output         (int index);
      void               flushBuffer    (void);
 
   protected:
      RTSoundIO         *truesound;           // STK sound interface

      short*             buffer;              // storage area for sound
      long               bufferSize;          // size of storage in samples
      int                bufferIndex;         // current pointer to buffer

      // private functions
      void               sendBuffer     (void);
      void               zeroSend       (void);  // send leftover frame
      
};



#endif  /* _LINUXSOUNDOUT_H_INCLUDED */



// md5sum: 357c3096f7bbea263caf170f50dfbe21 LinuxSoundOut.h [20010708]
