//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sat Nov  8 21:08:39 GMT-0800 1997
// Last Modified: Sat Nov  8 21:08:45 GMT-0800 1997
// Filename:      ...sig/maint/code/base/LookupTable/LookupTable.h
// Web Address:   http://sig.sapp.org/include/sigBase/LookupTable.h
// Documentation: http://sig.sapp.org/doc/classes/LookupTable
// Syntax:        C++ 
//

#ifndef _LOOKUPTABLE_H_INCLUDED
#define _LOOKUPTABLE_H_INCLUDED


#include "LookupTableCI.h"
#include "sigTypes.h"


class LookupTable : public LookupTableCI {
   public:
                         LookupTable             (int size = 0);
                         LookupTable             (sampleType* aTable, int size);
                         LookupTable             (const LookupTable& aTable);
                        ~LookupTable             ();

      void               doLinearInterpolation   (void);
      void               doConstantInterpolation (void);
      LookupTable&       operator=               (LookupTable& aTable);

   protected:
      int                interpolationType;

      sampleType         read                    (double index) const;
};



#endif  /* _LOOKUPTABLE_H_INCLUDED */



// md5sum: 539e3cb05eed8353097eb141f83139c1 LookupTable.h [20010708]
