//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Tue May 13 22:52:44 GMT-0800 1997
// Last Modified: Tue May 13 22:52:50 GMT-0800 1997
// Filename:      ...sig/maint/code/Filter/OnePole/OnePole.h
// Web Address:   http://sig.sapp.org/include/sigSignal/OnePole.h
// Documentation: http://sig.sapp.org/doc/classes/OnePole
// Syntax:        C++ 
//

#ifndef _ONEPOLE_H_INCLUDED
#define _ONEPOLE_H_INCLUDED


#include "Filter.h"


class OnePole : public Filter {
   public:
                         OnePole        (sampleType aFeeback = 0.0,
                                            sampleType aGain = 1.0);
                        ~OnePole        ();
      void               action         (void);
      sampleType         getFeedback    (void);
      sampleType         getGain        (void);
      sampleType         output         (int index);
      void               setFeedback    (sampleType aFeedback);
      void               setGain        (sampleType aGain);
 
   protected:
      sampleType         outputValue;
      sampleType         previousOutput;
      sampleType         gain;
      sampleType         feedback;
};



#endif  /* _ONEPOLE_H_INCLUDED */



// md5sum: b7ef81b694a46455b68da63c9080d96d OnePole.h [20010708]
