//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Jun  8 10:44:32 GMT-0800 1997
// Last Modified: Sun Jun  8 10:44:35 GMT-0800 1997
// Filename:      ...sig/maint/code/Filter/Pan2/Pan2.h
// Web Address:   http://sig.sapp.org/include/sigSignal/Pan2.h
// Documentation: http://sig.sapp.org/doc/classes/Pan2
// Syntax:        C++ 
//

#ifndef _PANTWO_H_INCLUDED
#define _PANTWO_H_INCLUDED

#include "Filter.h"
#include "Delay.h"


class Pan2 : public Filter {
   public:
                         Pan2           (void);
                        ~Pan2           ();
      void               action         (void);
      sampleType         getHeadSize    (void);
      sampleType         getSignal      (void);
      sampleType         getSpeedOfSound(void);
      sampleType         getX           (void);
      sampleType         getY           (void);
      sampleType         output         (int index);
      void               setHeadSize    (sampleType aSize);
      void               setSpeedOfSound(sampleType aSpeed);
      void               setX           (sampleType anX);
      void               setY           (sampleType aY);
 
   protected:
      sampleType         outputValueLeft;
      sampleType         outputValueRight;
      sampleType         distanceToLeftEar;
      sampleType         distanceToRightEar;
      sampleType         sampleDelay;
      sampleType         leftDelayIndex;
      sampleType         rightDelayIndex;
      Delay              delayline;
};



#endif  /* _PANTWO_H_INCLUDED */



// md5sum: 3cc4704bb24c3dff08cd4f58f7af4d5d Pan2.h [20010708]
