//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Mon Sep 15 12:16:30 GMT-0800 1997
// Last Modified: Mon Sep 15 12:16:36 GMT-0800 1997
// Filename:      ...sig/maint/code/LookupTable/PeriodTable/PeriodTable.h
// Web Address:   http://sig.sapp.org/include/sigBase/PeriodTable.h
// Documentation: http://sig.sapp.org/doc/classes/PeriodTable
// Syntax:        C++ 
//

#ifndef _PERIODTABLE_H_INCLUDED
#define _PERIODTABLE_H_INCLUDED


#include "LookupTable.h"
#include "sigTypes.h"
#include "sigDefines.h"


class PeriodTable : public LookupTable {
   public:
                         PeriodTable   (int size = 0);
                         PeriodTable   (sampleType* aTable, int size);
                         PeriodTable   (PeriodTable& aTable);
                         PeriodTable   (char* ostString, int size = 1024);
                        ~PeriodTable   ();
                      
      void               add           (int periods, double amp, 
                                          double phase = 0);
      void               add           (char* oscString);
      void               flip          (void);
      void               leftShift     (int amount);
      void               print         (void);
      void               ramp          (double amplitude = 1);
      void               remove        (int periods, double amp, 
                                          double phase = 0);
      void               reverse       (void);
      void               rightShift    (int amount);
      void               subtract      (char* oscString);
      void               sine          (double amplitude = 1);
      void               square        (double amplitude = 1);
      void               triangle      (double amplitude = 1); 
};



#endif  /* _PERIODTABLE_H_INCLUDED */



// md5sum: 193c688148811e76ccefc2738be674f4 PeriodTable.h [20010708]
