//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Wed Jun 11 07:00:50 GMT-0800 1997
// Last Modified: Wed Jun 11 07:00:53 GMT-0800 1997
// Filename:      ...sig/maint/code/Filter/ReverbA/ReverbA.h
// Web Address:   http://sig.sapp.org/include/sigSignal/ReverbA.h
// Documentation: http://sig.sapp.org/doc/classes/ReverbA
// Syntax:        C++ 
//

#ifndef _REVERBA_H_INCLUDED
#define _REVERBA_H_INCLUDED

#include "Reverb.h"
#include "Comb.h"
#include "Allpass.h"
#include "Add.h"
#include "Constant.h"
#include "Action.h"


class ReverbA : public Reverb {
   public:
                         ReverbA             (sampleType aReverbTime = 1.0);
                        ~ReverbA             ();
      void               action              (void);
      sampleType         getStoredReverbTime (void);
      sampleType         output              (int index);
      void               setStoredReverbTime (sampleType aReverbTime);
 
   protected:
      sampleType         reverbTime;
      Comb               comb1;
      Comb               comb2;
      Comb               comb3;
      Comb               comb4;
      Allpass            allpass1;
      Allpass            allpass2;
      Add                add;
      Constant           inputSignal;
      Action             act;
};



#endif  /* _REVERBA_H_INCLUDED */



// md5sum: d1b8d30b31d2f8a1154248fca1b6681f ReverbA.h [20010708]
