//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Tue Nov 12 15:17:54 PST 1996
// Last Modified: Tue Apr 29 21:38:49 GMT-0800 1997
// Filename:      ...sig/maint/code/Filter/SoundFileOut/SoundFileOut.h
// Web Address:   http://sig.sapp.org/include/sigSignal/SoundFileOut.h
// Documentation: http://sig.sapp.org/doc/classes/SoundFileOut
// Syntax:        C++ 
//

#ifndef _SOUNDFILEOUT_H_INCLUDED
#define _SOUNDFILEOUT_H_INCLUDED

#include "Filter.h"
#include "SoundHeader.h"

#ifndef OLDCPP
   #include <fstream>
   using namespace std;
#else
   #include <fstream.h>
#endif


class SoundFileOut : public Filter {
   public:
                     SoundFileOut      (char* aFileName, SoundHeader& header);
                    ~SoundFileOut      ();
      void           action            (void);
      void           close             (void);
      const char*    getFilename       (void) const;
      sampleType     output            (int channel);

      void           insertSample16Bit (short sample);
 
   protected:
      char          *filename;
      int            endianType;
      SoundHeader    sndHeader;
      FileIO         outFile;
      long           sampleCount;
      ushort         outSample;


      void           determineSampleWritingFunction   (void);
      
      void           (*writeSample)       (FileIO& outFile, sampleType aSample);


};



#endif  /* _SOUNDFILEOUT_H_INCLUDED */



// md5sum: 982f3769dea7ce0eba59a44aa6e0b5e4 SoundFileOut.h [20050403]
