//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Wed Apr 30 14:25:59 GMT-0800 1997
// Last Modified: Fri Oct 18 12:34:19 PDT 2002 (added choise of rand/drand48)
// Filename:      ...sig/maint/code/Generator/WhiteNoise/WhiteNoise.h
// Web Address:   http://sig.sapp.org/include/sigSignal/WhiteNoise.h
// Documentation: http://sig.sapp.org/doc/classes/WhiteNoise
// Syntax:        C++ 
//

#ifndef _WHITENOISE_H_INCLUDED 
#define _WHITENOISE_H_INCLUDED 

#include "Generator.h"

#define NOISE_SOURCE_RAND    0
#define NOISE_SOURCE_DRAND48 1
#define NOISE_SOURCE_OTHER   2

class WhiteNoise : public Generator {
   public:
                      WhiteNoise        (sampleType aMaxAmplitude = 1.0, 
                                           int randomSeed = 0);
                     ~WhiteNoise        ();
                      
      void            action            (void);
      sampleType      getAmplitude      (void);
      sampleType      output            (int channel);
      void            printState        (void);
      void            seed              (int aSeed = 0);
      void            setAmplitude      (sampleType anAmplitude);
      void            setSourceRand     (void);
      void            setSource48Bit    (void);
      int             getSource         (void);

   protected:
      sampleType      amplitude;
      sampleType      outputValue;
      int             noiseSource;       // 0 = rand, 1 = drand48, 
};



#endif  /* _WHITENOISE_H_INCLUDED */



// md5sum: 0a634ce917e007956488e5e4a72ffec5 WhiteNoise.h [20050403]
