//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Fri Feb  7 00:44:33 PST 1997
// Last Modified: Thu Feb 12 20:17:59 GMT-0800 1998
// Last Modified: Sun Jul  8 14:18:37 PDT 2001 (split defs and decls)
// Filename:      ...sig/maint/code/utilities/transforms/transforms-private.h
// Web Address:   http://sig.sapp.org/include/sig/transforms-private.h
// Syntax:        C++ 
//
// Description: Private helper functions for the Transforms.cc file.
//     Many of these functions are taken from:
//     Ofranidis, Sophocles J.  "Introduction to Signal Processing", 
//          Prentice Hall, 1996.  page 520.
//


#ifndef _TRANSFORMS_PRIVATE_H_INCLUDED
#define _TRANSFORMS_PRIVATE_H_INCLUDED


#include "Block.h"
#include "ComplexD.h"
#include <math.h>

void     fft_destructive(Block<ComplexD>& X);
void     ifft_destructive(Block<ComplexD>& X);
void     shuffle(Block<ComplexD>& X);
void     dftmerge(Block<ComplexD>& X);
void     swap(ComplexD& a, ComplexD& b);
int      bitrev(int n, int B);
ComplexD makeComplex(double rePart, double imagPart);
ComplexD cexp(ComplexD Z);
int      poweroftwo(long number);



#endif  /* _TRANSFORMS_PRIVATE_H_INCLUDED */



// md5sum: 2854275438cd5d30360ed5e8bc71634c transforms-private.h [20010708]
