//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Mon Apr 28 21:46:28 GMT-0800 1997
// Last Modified: Mon Apr 28 21:46:28 GMT-0800 1997
// Filename:      ...sig/maint/code/Generator/Constant/Constant.cpp
// Web Address:   http://sig.sapp.org/src/sigSignal/Constant.cpp
// Documentation: http://sig.sapp.org/doc/classes/Constant
// Syntax:        C++ 
//

#include "Constant.h"

#ifndef OLDCPP
   #include <iostream>
   using namespace std;
#else
   #include <iostream.h>
#endif


//////////////////////////////
//
// Constant::Constant --
//	default value: aValue = 0
//

Constant::Constant(sampleType aValue) {
   setName("Constant");
   value = aValue;
   brandname = GENERATOR;
}



//////////////////////////////
//
// Constant::~Constant --
//

Constant::~Constant() { }



//////////////////////////////
//
// Constant::action --
//

void Constant::action(void) { }



//////////////////////////////
//
// Constant::output --
//

sampleType Constant::output(int channel) { 
   return value;
}



//////////////////////////////
//
// Constant::printState --
//

void Constant::printState(void) { 
   cerr << "Constant value = " << value << endl;
}


//////////////////////////////
//
// Constant::setValue --
//

void Constant::setValue(sampleType aValue) { 
   value = aValue;
}



// md5sum: 34e91d354093e9955f92d2fdf64d317c Constant.cpp [20050403]
