//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Mar  7 17:35:12 PST 1999
// Last Modified: Sun Mar  7 17:36:29 PST 1999
// Filename:      ...sig/maint/code/Filter/LogisticLimiter/LogisticLimiter.cpp
// Web Address:   http://sig.sapp.org/src/sigSignal/LogisticLimiter.cpp
// Documentation: http://sig.sapp.org/doc/classes/LogisticLimiter
// Syntax:        C++ 
//

#include "LogisticLimiter.h"
#include <stdlib.h>
#include <math.h>


//////////////////////////////
//
// LogisticLimiter::LogisticLimiter --
//

LogisticLimiter::LogisticLimiter(void) {
   setName("LogisticLimiter");
   brandname = FILTER;
   clear();
}



//////////////////////////////
//
// LogisticLimiter::~LogisticLimiter --
//

LogisticLimiter::~LogisticLimiter() { 
   // do nothing
}



//////////////////////////////
//
// LogisticLimiter::action --
//

void LogisticLimiter::action(void) {
   outputValue = 2.0/(1.0 + exp(-inputs[0])) - 1;
}



//////////////////////////////
//
// LogisticLimiter::clear --
//

void LogisticLimiter::clear(void) {
   outputValue = 0.0;
}



//////////////////////////////
//
// LogisticLimiter::output --
//

sampleType LogisticLimiter::output(int channel) {
   return outputValue;
}



//////////////////////////////
//
// LogisticLimiter::printState --
//

void LogisticLimiter::printState(void) {
      cout << "LogisticLimiterInput[0] = " << inputs[0] << endl;
      cout << "LogisticLimiterOutput[0] = " << outputValue << endl;
}



// md5sum: 4d77ad850cf8cd7b5362673a83f33fa1 LogisticLimiter.cpp [20010708]
