//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Nov 17 00:41:03 PST 1996
// Last Modified: Wed Apr 23 22:38:37 GMT-0800 1997
// Filename:      ...sig/maint/code/Filter/Scale/Scale.cpp
// Web Address:   http://sig.sapp.org/src/sigSignal/Scale.cpp
// Documentation: http://sig.sapp.org/doc/classes/Scale
// Syntax:        C++ 
//

#include "Scale.h"
#include <stdlib.h>


//////////////////////////////
//
// Scale::Scale --
//	default value = 1.0
//

Scale::Scale(sampleType value) {
   setName("Scale");
   scaleValue = value;
   Output.allowGrowth();
   Output.zero();
   brandname = FILTER;
}



//////////////////////////////
//
// Scale::action --
//

void Scale::action(void) {
   for (int i=0; i<inputs.getSize(); i++) {
      Output[i] = scaleValue * inputs[i];
   }
}



//////////////////////////////
//
// Scale::getScale --
//

sampleType Scale::getScale(void) {
   return scaleValue;
}



//////////////////////////////
//
// Scale::output --
//

sampleType Scale::output(int channel) {
   return Output[channel];
}



//////////////////////////////
//
// Scale::setScale --
//

void Scale::setScale(sampleType newScale) {
   scaleValue = newScale;
}



// md5sum: 87dacf56a66e5b2244f3806623fa89dc Scale.cpp [20010708]
