//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Tue Apr 29 22:22:22 GMT-0800 1997
// Last Modified: Tue Apr 29 22:42:56 GMT-0800 1997
// Filename:      ...sig/maint/code/Filter/UserOut/UserOut.cpp
// Web Address:   http://sig.sapp.org/src/sigSignal/UserOut.cpp
// Documentation: http://sig.sapp.org/doc/classes/UserOut
// Syntax:        C++ 
//

#include "UserOut.h"
#include <stdlib.h>
#include <string.h>


//////////////////////////////
//
// UserOut::UserOut --
//    default value: aTag = "UserOut"
//

UserOut::UserOut(char *aTag) {
   setName("UserOut");
   tag = NULL;
   setTag(aTag);
   brandname = FILTER;
}



//////////////////////////////
//
// UserOut::action --
//

void UserOut::action(void) {
   for (int i=0; i<inputs.getSize(); i++) {
      cout << tag << ": i = " << i << "\t value = " << inputs[i] << endl;
   }
}



//////////////////////////////
//
// UserOut::output --
//

sampleType UserOut::output(int channel) {
   return inputs[channel];
}



//////////////////////////////
//
// UserOut::setTag --
//

void UserOut::setTag(char *aTag) {
   if (tag != NULL) delete [] tag;
   tag = new char[strlen(aTag)+1];
   strcpy(tag, aTag);
}



// md5sum: c2c1d0ed41b250db0750735035e10c5b UserOut.cpp [20010708]
